package com.starwsn.test;

import com.starwsn.protocol.core.Starwsn;
import org.eclipse.paho.client.mqttv3.IMqttDeliveryToken;
import org.eclipse.paho.client.mqttv3.MqttCallback;
import org.eclipse.paho.client.mqttv3.MqttMessage;

public class MessageCallback  implements MqttCallback{
	
	public void connectionLost(Throwable cause) {
		System.out.println("mqtt服务断开连接！！！");
		for(int i = 0; i < 10000; i++) {
			System.out.println("第【" + (i + 1) + "】次尝试连接MQTT服务");
			boolean cb = MqttServices.connect(false);
			if (cb) {
				System.out.println("mqtt服务重连成功！！！");
				/*
				* 设备重连成功后需重新订阅所有设备消息主题
				* */
				break;
			}
			try {
				if(i<5){
					Thread.sleep(5000);
				}else if(i>=5 && i<10){
					Thread.sleep(10000);
				}else{
					Thread.sleep(60000);
				}
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
			if(i==9999){
				System.out.println("mqtt服务重连失败！！！");
			}
		}
	}

	public void deliveryComplete(IMqttDeliveryToken token) {
	}

	public void messageArrived(String topic, MqttMessage message) {
		try {
			String[] topics = topic.split("/");
			//设备参数配置主题 ,平台端无需处理，所以接收到此类主题消息直接返回。针对非NB类产品
			if("set_para".equals(topics[2])){
				return;
			}
			/* 消息处理需构建独立线程类来处理，确保本函数可及时返回，避免消息阻塞 */
			// 消息体
			byte[] payLoadArray = message.getPayload();
			//消息解析
			String jsonStr = Starwsn.messageResolve(topic, payLoadArray);
			System.out.println(JsonFormatUtil.formatJson(jsonStr));
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
