package com.starwsn.test;

import com.starwsn.protocol.common.CmdCode;
import com.starwsn.protocol.core.MqttCmd;
import com.starwsn.protocol.core.Starwsn;
import com.starwsn.protocol.dto.CommandInfoDto;

public class Test {

	public static void main(String[] args) {
		Test test = new Test();
		//构建MQTT连接
		boolean cb = test.testInitMqtt();
		if(cb){
			//订阅设备,三级主题使用通配符，设备所有类别消息均可接收
			test.testSubScriptionDevice("ND/ABC123/#");    //一杆式内涝监测站（SE200）
			test.testSubScriptionDevice("ND/ABC124/#");    //消火栓智能监测装置（SF500）
			test.testSubScriptionDevice("ND/ABC125/#");    //一杆式河道监测站(SE500)
			test.testSubScriptionDevice("ND/ABC126/#");    //无线温湿度传感器(SH500)
			test.testSubScriptionDevice("ND/ABC127/#");    //井盖状态监测仪(SJ300)
			test.testSubScriptionDevice("ND/ABC128/#");    //污水立管返水监测报警器(SN100)
			test.testSubScriptionDevice("ND/ABC129/#");    //无线压力变送器(SP300)
			test.testSubScriptionDevice("ND/ABC130/#");    //管道流量监测仪(SR500)
			test.testSubScriptionDevice("ND/ABC131/#");    //流量电导监测仪(SR500)
			test.testSubScriptionDevice("ND/ABC132/#");    //无线液位变送器(SY800)
			/*
			* 上述为测试环境提供的几类产品的样例设备，因产品类别较多，未列出所有产品，但所有产品报文结构是统一的，可根据相近产品报文做为参照。
			* 测试环境下的设备为程序模拟，主要用于对接测试联调，监测报文上报及监测数值不具有的业务逻辑性。
			* */
		}

		//配置设备参数，按需调用。
		/*
		 * 特别注意：
		 *    设备采集周期、上报周期影响设备电池整体使用寿命，无特别需求不要调整，不要调整，不要调整
		 */
		//test.testPostDeviceCommand();
	}

	/**
	 * 初始始化MQTT客户端并构建连接
	 * @return MQTT客户端连接状态
	 */
	public boolean testInitMqtt(){
		return MqttServices.connect(true);
	}

	/**
	 * 订阅设备消息主题
	 * @param topic 消息主题
	 */
	public void testSubScriptionDevice(String topic){
		MqttServices.subScription(topic,1);
	}

	/**
	 * 设备参数配置样例
	 * 根据业务需要封装相应函数，按需调用
	 */
	public void testPostDeviceCommand(){
		CommandInfoDto dto = new CommandInfoDto(); //配置设备参数函数接收参数对象
		dto.setApiKey("123");  //ApiKey从客户经理或技术支持处获取
		dto.addSncode("AAA111");  //设备SN码
		dto.addCommandInfo(CmdCode.PRESSURE_UPPER_LIMIT,"650");  //期望配置的对应设备的参数项及参数值
		String result = Starwsn.postDeviceCommand(dto);
		System.out.println(result);
	}

	/**
	 * 非NB类设备参数配置
	 * 根据业务需要封装相应函数，按需调用
	 */
	public void testGetCommandPayload(){
		byte[] cmdPayload = MqttCmd.getCmdInfo("0x0401,0x0402","3600,900");
		MqttServices.publish("ND/KP0E90/set_para",cmdPayload);
	}
}
